﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WorldServerLibrary.Model
{
    public enum MotorSystemType
    {
        CAR,
        TWO_WHEEL
    }

    public class Creature:Thing
    {
        public Int32 index { get; set; }
		public MotorSystemType MotorSystem { get; set; }
        public double Wheel { get; set; }
        public double Speed { get; set; }
        public double Fuel { get; set; }
		public double serotonin { get; set; }
		public double endorphine { get; set; }
        public Boolean HasLeaflet { get; set; }
        public Int32 NumberOfLeaflets { get; set; }
		public List<Leaflet> Leaflets { get; set; }
		public double score { get; set; }
		public double XX1 { get; set; }
		public double YY1 { get; set; }
		public double XX2 { get; set; }
		public double YY2 { get; set; }
		public string actionData { get; set; }
		public Boolean HasCollided { get; set; }

		public Boolean IsLeafletMissingJewel(String color) {
			int missingofthiscolor = 0;
			foreach (Leaflet l in Leaflets) {
				int i = l.getMissingNumberOfType (color);
				if (i >= 0) {
					missingofthiscolor += i;
				}
			}
			return (missingofthiscolor > 0);
		}

		public void updateLeafletWithKnapsack(IList<Thing> knap) {
			
			foreach (Thing t in knap) {
				foreach (Leaflet l in Leaflets) {
					String before = l.toString ();
					if (l.ifInLeaflet(t.Material.Color)) {
						Dictionary<String, int[]> items = l.getItems();
						int[] counter = items[t.Material.Color];
						if (counter [0] >
							counter [1]) {
							counter [1] += 1;
							items [t.Material.Color] = counter;
							break;
						}
						//l.setItems(items);
					}
					if (l.toString ().CompareTo (before) != 0) {
						//Console.WriteLine ("Before: " + l.toString());
						//Console.WriteLine ("After: " + before);
					}
				}
			}
		}

		public bool isLeafletCompleted() {
			int totalMissing = 0;
			foreach (Leaflet l in Leaflets) {
				totalMissing += l.getTotalMissing ();
			}
			//Console.WriteLine ("Total Missing = " + totalMissing);
			return (totalMissing == 0);
		}
			
    }
}
